#!/usr/bin/perl

###########################################################################
# HITLOG - Main Script File                                   Version 1.1 #
# Written by Patrick Dingle                     dimension@cgiworkshop.com #
# Released February 7, 1999         A Product of Dimension's CGI Workshop #
# ----------------------------------------------------------------------- #
# Dimension's CGI Workshop:         http://www.cgiworkshop.com/dimension/ #
# ----------------------------------------------------------------------- #
# Copyright (c) 1998-1999 Patrick Dingle, All Rights Reserved.  This      #
# program may not be modified or redistributed in any way without the     #
# expressed consent of Patrick Dingle, with the exception of the marked   #
# portions.  This program is provided AS IS.  Neither Patrick Dingle nor  #
# Dimension's CGI Workshop is responsible for any damaged caused,         #
# directly or indirectly, by the usage of this program. This notice must  #
# remain in place under any circumstances.                                #
###########################################################################

###########################################################################
# You may modify the following global constant variables

# ***** LOCATION AND NAME OF THE LOG FILE (DATA FILE) *****
# Enter the location (not URL) and name of the log file below.  If you want
# the log file to be in the same directory as this file (usually in the
# cgi-bin directory), you do not need to enter a path.

$logfile = "hitlog.dat";

# ***** LOCATION AND NAME OF THE TEMPORARY GIF FILE *****
# Enter the location (not URL) and name of the temporary graphic file
# below.  This file should not be in the same directory as the cgi-bin.  If
# the graphic file will be located one directory up from the cgi-bin
# directory, you can leave the path as is (with a ../ before the file
# name).

$tempgif = "../tempgif.gif";

# ***** LOCATION AND NAME OF THE HITLOG STATISTICS SCRIPT *****
# Enter the location (not URL) and name of the statistics script below.  If
# you want the script to be in the same directory as this file (usually it
# is a good idea to keep all the scripts in the same directory), you do not
# need to have a path.

$statsfile = "hlstats.pl";

# ***** LOCATION AND NAME OF THE HITLOG ADMIN SCRIPT *****
# Enter the location (not URL) and name of the admin script below.  If
# you want the script to be in the same directory as this file (usually it
# is a good idea to keep all the scripts in the same directory), you do not
# need to have a path.

$adminfile = "hladmin.pl";

# ***** URL OF THIS FILE *****
# Enter the complete URL to this script below.

$thisfileurl = "http://www.yourdomain.com/cgi-bin/hitlog.pl";

# ***** URL OF THE DIRECTORY CONTAINING GRAPHIC FILES *****
# Enter the complete URL to the directory containing go.gif, hitlog11.gif,
# minilogo.gif, and bargraph.gif below.

$gifdir = "http://www.yourdomain.com/graphics/";

# ***** URL OF THE TEMPORARY GIF FILE *****
# Enter the complete URL to the temporary GIF file you specified above.

$tgifurl = "http://www.yourdomain.com/graphics/tempgif.gif";

# ***** DISPLAY GRAPHIC ON YOUR WEB PAGE? *****
# If you would like a small "HitLog 1.1" graphic to be displayed on your
# web page that links to your statistics page, enter YES inside the
# quotation marks below.  Enter NO if you do not want the graphic to be
# shown.

$displaylogo = "YES";

# ***** ADMINISTRATOR PASSWORD *****
# Enter a password that you will need to use the administration functions.

$password = "yourpass";

#                     End of global variable settings                     #
# ********************* DO NOT EDIT BELOW THIS LINE ********************* #
###########################################################################

print "Content-type: text/html\n\n";

$query = $ENV{QUERY_STRING};

$chp = chop($gifdir);

if ($chp ne "/") { $gifdir = "$gifdir" . "$chp" . "/"; }
if ($chp eq "/") { $gifdir = "$gifdir" . "/"; }

$titlegif = "$gifdir" . "hitlog11.gif";
$gogif = "$gifdir" . "go.gif";
$minilogourl = "$gifdir" . "minilogo.gif";
$bargraph = "$gifdir" . "bargraph.gif";

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
if ($sec < 10) { $sec = "0$sec"; }
if ($min < 10) { $min = "0$min"; }
$mon++;
@months = (January, February, March, April, May, June, July, August, September, October, November, December);
$month = $months[$mon - 1];

if ($year <= 97) { $yr = "20$year"; }
if ($year >= 98) { $yr = "19$year"; }

$ampm = "A.M.";
$hr = $hour;
if ($hour >= 12) { $hr = $hour - 12; $ampm = "P.M."; }
if ($hr eq 0) { $hr = 12; }

if ($query eq "")
{
	if ($ENV{'DOCUMENT_URI'} ne "") {
		open(FILE, ">>$logfile");
		
		$addr = $ENV{'REMOTE_ADDR'};

		local($ip_address) = $addr;
		$ip_address =~ s/^\s+|\s+$//g;
		local(@bytes) = split(/\./, $ip_address);
		local($packaddr) = pack("C4",@bytes);
		local($host_name) = (gethostbyaddr($packaddr, 2))[0];
		print FILE "$mon|$mday|$year|$hour|$min|$sec|$ENV{'DOCUMENT_URI'}|$addr|$ENV{'HTTP_REFERER'}|$host_name\n";
		close(FILE);
		if ($displaylogo eq "YES") {
			print "<a href=\"http://www.cgiworkshop.com/dimension/free/hitlog\"><img src=\"$minilogourl\" border=0></a>\n";
		}
	}
	else {
		print "<html><head><title>HitLog 1.1</title></head><body bgcolor=black text=white link=yellow vlink=yellow alink=cyan>\n";
		print "<center><img src=\"$titlegif\"></center><hr>\n";
		print "<font color=white size=2 face=arial><b>This is the HitLog 1.1 main script file.  HitLog 1.1 was designed and developed in it's entirty by Patrick Dingle (Dimension).  This script is freeware and can be found at <a href=\"http://www.cgiworkshop.com/dimension\">Dimension's CGI Workshop</a>.  Please follow the links below to use HitLog 1.1.<hr>\n";
		print "<font size=+1><a href=\"hitlog.pl?stats\">HitLog 1.1 <i>Statistics Page</i></a><p>\n";
		print "<a href=\"hitlog.pl?admin\">HitLog 1.1 <i>Administration Page</i></a></font></b></font><hr>\n";
		print "<center><font color=white size=2 face=\"arial\">Copyright (c) 1998-1999 <i>Dimension's CGI Workshop</i>, all rights reserved.</font></center>\n";
		print "</body></html>\n";
	}
}

open(FILE, ">>$logfile");
close(FILE);

if ($query eq "stats")
{
	open(FILE, "$logfile");
	@indata = <FILE>;
	close(FILE);
	$count = 0;
	foreach $temp (@indata) {
		$count++; }
	if ($count ne 0) { $count--; }
	print "<html><head><title>HitLog 1.1 Statistics Page</title></head>\n";
	print "<body bgcolor=black link=yellow vlink=yellow alink=cyan>\n";
	print "<center><table width=620 border=0 bgcolor=black><tr><td bgcolor=black width=100%>\n";
	print "<center><img src=\"$titlegif\">\n";
	print "<br><font color=white size=2 face=\"arial\"><b>A product of <a href=\"http://www.cgiworkshop.com/dimension/\">Dimension's CGI Workshop</a></b></font></center>\n";
	print "<hr size=5>\n";
	print "<font color=white size=2 face=\"arial\"><b><center>There have been <i>$count</i> hits logged by <font color=yellow>HitLog 1.1</font>.<br>\n";
        print "Today is $month $mday, $yr, and the time is $hr:$min $ampm</center></b></font>\n";
	print "<hr size=5>\n";
	print "<font color=cyan size=3 face=\"arial\"><b><i>View hits by specific time period</i></b></font><br>\n";
	print "<font color=white size=2 face=\"arial\"><b>Use this feature to view a table of all the hits on a certain date, week, or time period.</b></font>\n";
	print "<form action=\"$statsfile\" method=POST>\n";
	print "<input type=hidden name=\"logfile\" value=\"$logfile\">\n";
	print "<input type=hidden name=\"tempgif\" value=\"$tempgif\">\n";
	print "<input type=hidden name=\"tgifurl\" value=\"$tgifurl\">\n";
	print "<input type=hidden name=\"date\" value=\"$mon|$mday|$year\">\n";
	print "<input type=hidden name=\"bargraph\" value=\"$bargraph\">\n";
	print "<table border=0>\n";

	print "<tr><td colspan=2 width=175><font color=yellow size=3 face=\"arial\"><b>By Date</b></font></td>\n";
	print "<td colspan=2 width=185><font color=yellow size=3 face=\"arial\"><b>24 hours / 7 days</b></font></td>\n";
	print "<td colspan=2 width=250><font color=yellow size=3 face=\"arial\"><b>Other</b></font></td></tr>\n";

        print "<tr><td width=100><font color=white size=3>Today</font></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"Today\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"Today\" ALT=\"Today's Hits\"></td>\n";
	print "<td width=110><font color=white size=3>Last 24 hours</font></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"24hours\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"24hours\" ALT=\"Last 24 Hours\"></td>\n";
	print "<td width=200><font color=white size=3>Between the following dates:</font></td><td width=50></td></tr>\n";

        print "<tr><td width=100><font color=white size=3>Yesterday</font></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"Yesterday\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"Yesterday\" ALT=\"Yesterday's Hits\"></td>\n";
	print "<td width=110><font color=white size=3>Last 7 days</font></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"7days\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"7days\" ALT=\"Last 7 Days\"></td>\n";
	print "<td width=200><input type=text size=2 name=\"bmonth\" value=\"MM\"><input type=text size=2 name=\"bday\" value=\"DD\"><input type=text size=2 name=\"byear\" value=\"YY\"> <font color=white size=3>-</font> <input type=text size=2 name=\"emonth\" value=\"MM\"><input type=text size=2 name=\"eday\" value=\"DD\"><input type=text size=2 name=\"eyear\" value=\"YY\"></td><td width=50><INPUT TYPE=\"image\" src=\"$gogif\" name=\"2dates\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"2dates\" ALT=\"Between these dates\"></td></tr>\n";

	print "<tr><td width=100><input type=text size=2 name=\"spmonth\" value=\"MM\"><input type=text size=2 name=\"spday\" value=\"DD\"><input type=text size=2 name=\"spyear\" value=\"YY\"></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"Specific\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"Specific\" ALT=\"Specific Date\"></td>\n";
	print "<td width=110><font color=white size=3>Last 60 Minutes</font></td><td align=left width=75><INPUT TYPE=\"image\" src=\"$gogif\" name=\"60minutes\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"60minutes\" ALT=\"Last 60 Minutes\"></td>\n";
	print "<td width=200><font color=white size=3>View the last <input type=text name=\"lhits\" size=3 value=\"50\"> hits&nbsp;&nbsp;</font></td><td align=left width=50><INPUT TYPE=\"image\" src=\"$gogif\" name=\"sphits\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"sphits\" ALT=\"View specific number of hits\"></td></tr>\n";

	print "</table>\n";
	print "<hr size=5>\n";

	print "<font color=cyan size=3 face=\"arial\"><b><i>View Line Graphs (GIF)</i></b></font><br>\n";
	print "<font color=white size=2 face=\"arial\"><b>Use this feature to graph various information about hits to your site.</b></font><p>\n";
	print "<font color=white size=3 face=\"arial\">\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"10days\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"10days\" ALT=\"Hits: Last 10 Days\">&nbsp;&nbsp;Hits: Last 10 days<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"20days\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"20days\" ALT=\"Hits: Last 20 Days\">&nbsp;&nbsp;Hits: Last 20 days<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"50days\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"50days\" ALT=\"Hits: Last 50 Days\">&nbsp;&nbsp;Hits: Last 50 days<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"100days\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"100days\" ALT=\"Hits: Last 100 Days\">&nbsp;&nbsp;Hits: Last 100 days<br>\n";

	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"hour\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"hour\" ALT=\"Average hits by hour\">&nbsp;&nbsp;Average hits by hour<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"dayofweek\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"dayofweek\" ALT=\"Average hits by day of week\">&nbsp;&nbsp;Average hits by day of week\n";
	print "</font>\n";
	print "<hr size=5>\n";
	print "<font color=cyan size=3 face=\"arial\"><b><i>View Horizontal Bar Graphs</i></b></font><br>\n";
	print "<font color=white size=2 face=\"arial\"><b>Use these options to display graphs of <i>domains of referring URLs</i>, <i>hits to local documents</i>, and <i>the domains of users' IP addresses</i>.</b></font><p>\n";
	print "<font color=white size=3 face=\"arial\">\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"domains\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"domains\" ALT=\"Domains of Referring URLs\">&nbsp;&nbsp;Domains of Referring URLs<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"localdocumenthits\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"localdocumenthits\" ALT=\"Local Document Hits\">&nbsp;&nbsp;Local Document Hits<br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"address\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"address\" ALT=\"First Level Domains of Visitors\">&nbsp;&nbsp;First Level Domains of Visitors<br>\n";
	print "</font>\n";
	print "<hr size=5><center><font color=white size=2 face=\"arial\">Copyright (c) 1998-1999 <i>Dimension's CGI Workshop</i>, all rights reserved.</font></center>\n";
	print "</td></tr></table></center></form>\n";
	print "</body></html>\n";
}

elsif ($query eq "admin")
{
	open(FILE, "$logfile");
	@indata = <FILE>;
	close(FILE);
	$count = 0;
	foreach $temp (@indata) {
		$count++;
		$len = length ($temp);
		$fsize = $fsize + $len;
	}
	if ($count ne 0) { $count--; }
	print "<html><head><title>HitLog 1.1 Administrator Page</title></head>\n";
	print "<body bgcolor=black link=yellow vlink=yellow alink=cyan>\n";
	print "<center><table width=620 border=0 bgcolor=black><tr><td bgcolor=black width=100%>\n";
	print "<center><font color=cyan size=6 face=arial><b>HitLog 1.1 Administrator Page</b></font></center>\n";
	print "<hr size=5>\n";
	print "<font color=white size=2 face=\"arial\"><b><center>There have been <i>$count</i> hits logged by <font color=yellow>HitLog 1.1</font>. <br>The HitLog 1.1 data file currently occupies $fsize bytes.</b></font></center><hr size=5>\n";
	print "<font color=white face=\"arial\" size=2><b>This administrator page allows you to delete portions of the HitLog log file.  You may delete the entire file, delete portions by date, or delete portions by the number of logs.  A password is required to use these features.</b></font><hr size=5>\n";
	print "<form action=\"$adminfile\" method=POST>\n";
	print "<font color=white size=3 face=\"arial\">Password: <input type=password size=10 name=\"pass\"></font><p>\n";
	print "<hr size=5>\n";
	print "<input type=hidden name=\"logfile\" value=\"$logfile\">\n";
	print "<input type=hidden name=\"hladmin\" value=\"$adminfile\">\n";
	$in = $password;
	$len = length($in);for ($temp = $len; $temp >= 1; $temp--){    $str[$temp] = chop($in);    $ascii[$temp] = ord $str[$temp];}
	$add = int(rand 3) + 1;$enc = $add;for ($x = 1; $x <= $len; $x++){    $randasc = int(rand 57) + 65;    $ascii[$x] = $ascii[$x] + $add;    $add1 = chr $ascii[$x];    $add2 = chr $randasc;    $enc = $enc . $add1;    $enc = $enc . $add2;}
	$in = $enc;$len = length($in);for ($temp = $len; $temp >= 1; $temp--){    $str[$temp] = chop($in);    $ascii[$temp] = ord $str[$temp];}
	$add = int(rand 3) + 1;$enc = $add;for ($x = 1; $x <= $len; $x++){    $randasc = int(rand 57) + 65;    $ascii[$x] = $ascii[$x] + $add;    $add1 = chr $ascii[$x];    $add2 = chr $randasc;    $enc = $enc . $add1;    $enc = $enc . $add2;}
	$password = $enc;
	print "<input type=hidden name=\"realpassword\" value=\"$password\">\n";
	print "<font color=cyan size=3 face=\"arial\"><b><i>Delete by hits</i></b></font><p>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"lhits\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"lhits\" ALT=\"Delete specific number of hits\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete the last (latest) <input type=text name=\"lhits\" size=3 value=\"50\"> hits&nbsp;&nbsp;</font><br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"fhits\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"fhits\" ALT=\"Delete specific number of hits\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete the first (earliest) <input type=text name=\"fhits\" size=3 value=\"50\"> hits&nbsp;&nbsp;</font>\n";
	print "<hr size=5>\n";
	print "<font color=cyan size=3 face=\"arial\"><b><i>Delete by date</i></b></font><p>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"Specific\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"Specific\" ALT=\"Specific Date\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete all hits <b>on</b> <input type=text size=2 name=\"spmonth1\" value=\"MM\"><input type=text size=2 name=\"spday1\" value=\"DD\"><input type=text size=2 name=\"spyear1\" value=\"YY\">.</font><br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"onorbefore\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"onorbefore\" ALT=\"On or Before a Specific Date\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete all hits <b>on</b> or <b>before</b> <input type=text size=2 name=\"spmonth2\" value=\"MM\"><input type=text size=2 name=\"spday2\" value=\"DD\"><input type=text size=2 name=\"spyear2\" value=\"YY\">.</font><br>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"onorafter\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"onorafter\" ALT=\"On or After a Specific Date\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete all hits <b>on</b> or <b>after</b> <input type=text size=2 name=\"spmonth3\" value=\"MM\"><input type=text size=2 name=\"spday3\" value=\"DD\"><input type=text size=2 name=\"spyear3\" value=\"YY\">.</font>\n";
	print "<hr size=5>\n";
	print "<font color=cyan size=3 face=\"arial\"><b><i>Delete entire log file</i></b></font><p>\n";
	print "<INPUT TYPE=\"image\" src=\"$gogif\" name=\"entire\" border=\"0\" WIDTH=43 HEIGHT=15 VALUE=\"entire\" ALT=\"Delete specific number of hits\">&nbsp;&nbsp;<font color=white size=3 face=\"arial\">Delete the entire log file&nbsp;&nbsp;</font>\n";
	print "<hr size=5><center><font color=white size=2 face=\"arial\">Copyright (c) 1998-1999 <i><a href=\"http://www.cgiworkshop.com/dimension\">Dimension's CGI Workshop</a></i>, all rights reserved.</font></center>\n";
	print "</td></tr></table></center></form>\n";
	print "</body></html>\n";
}