#!/usr/bin/perl

###########################################################################
# HITLOG - Statistics Script File                             Version 1.1 #
# Written by Patrick Dingle                     dimension@cgiworkshop.com #
# Released February 7, 1999         A Product of Dimension's CGI Workshop #
# ----------------------------------------------------------------------- #
# Dimension's CGI Workshop:         http://www.cgiworkshop.com/dimension/ #
# ----------------------------------------------------------------------- #
# Copyright (c) 1998-1999 Patrick Dingle, All Rights Reserved.  This      #
# program may not be modified or redistributed in any way without the     #
# expressed consent of Patrick Dingle, with the exception of the marked   #
# portions.  This program is provided AS IS.  Neither Patrick Dingle nor  #
# Dimension's CGI Workshop is responsible for any damaged caused,         #
# directly or indirectly, by the usage of this program. This notice must  #
# remain in place under any circumstances.                                #
###########################################################################

###########################################################################
# *** NO GLOBAL CONSTANT VARIABLES NEED TO BE MODIFIED IN THIS SCRIPT *** #
###########################################################################

use GD;

print "Content-type:text/html\n\n";

### PARSE FORM ###
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;    $FORM{$name} = $value;
}

### READ HIDDEN VARIABLES FROM SUBMITTED FORM ###
$logfile = $FORM{logfile};
$tempgif = $FORM{tempgif};
$date = $FORM{date};
$tgifurl = $FORM{tgifurl};
$bargraph = $FORM{bargraph};
($tmonth, $tday, $tyear) = split(/\|/, $date);

print "$tempgifurl\n";

### DAYS IN EACH MONTH OF YEAR.  DETERMINE IF LEAP YEAR ###
@daysinmonth = (0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
if (($tyear / 4) eq int($tyear / 4)) { $daysinmonth[2] = 29; }

### DETERMINE TODAY'S DATE & TIME
@normal = ("0","31","28","31","30","31","30","31","31","30","31","30","31");
@leap = ("0","31","29","31","30","31","30","31","31","30","31","30","31");
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
if ($sec < 10) { $sec = "0$sec"; }
if ($min < 10) { $min = "0$min"; }
$mon++;
@months = (January, February, March, April, May, June, July, August, September, October, November, December);
$month = $months[$mon - 1];
if ($year <= 97) { $yr = "20$year"; }
if ($year >= 98) { $yr = "19$year"; }
$ampm = "A.M.";
$hr = $hour;
if ($hour >= 12) { $hr = $hour - 12; $ampm = "P.M."; }


### OPEN & READ LOG FILE ###
open(FILE, "$logfile");
@infile = <FILE>;
close(FILE);

### DETERMINE IF THE USER SELECTED TO MAKE A GRAPH OR VIEW A CHART OF HITS ###
foreach $key (keys(%FORM))
{   
	chop($key);
	$c = chop($key);
	if ($c eq '.') { $q = $key; }
}
if ($q eq "Today" || $q eq "Yesterday" || $q eq "Specific" || $q eq "24hours" || $q eq "7days" || $q eq "60minutes" ||
    $q eq "2dates" || $q eq "sphits") { $option = "chart"; }
elsif ($q eq "10days" || $q eq "20days" || $q eq "50days" || $q eq "100days" || $q eq "hour" || $q eq "dayofweek") {
	$option = "graph"; }
else { $option = "bars"; }

print "<html><head><title>HitLog 1.1 - Statistics</title></head><body bgcolor=black text=white link=yellow vlink=yellow alink=cyan>\n";
print "<center><table width=620 border=0 bgcolor=black><tr><td bgcolor=black width=100%>\n";
print "<center><font color=cyan size=6 face=\"arial\"><b>HitLog 1.1 Statistics</b></font><br>\n";
print "<font color=white size=4 face=\"arial\"><b>\n";

### IF CHART ###
if ($option eq "chart") {
	$credit = 0;
	$bad = "yes";
	if ($q eq "Today") {
		$bad = "no";
		$styear = $year;
		$stmonth = $mon;
		$stday = $mday;
		$sthour = 0;
		$stminute = 0;
		$endyear = $year;
		$endmonth = $mon;
		$endday = $mday;
		$endhour = 24;
		$endminute = 00;	
		print "Today's Hits\n";
	}
	elsif ($q eq "Yesterday")
	{
		$bad = "no";
		$stday = $mday - 1;
		$styear = $year;
		$stmonth = $mon;
		$sthour = 0;
		$stminute = 0;
		$endyear = $year;
		$endmonth = $mon;
		$endday = $mday;
		$endhour = 0;
		$endminute = 0;	
		if ($stday eq 0) {
			$stmonth--;
			if ($stmonth eq 0) {
				$styear--;
				$stmonth=12;
			}
			$stday = $daysinmonth[$stmonth];
		}

		print "Yesterday's Hits\n";
	}
	elsif ($q eq "Specific")
	{
		if ($FORM{spmonth} >= 1 && $FORM{spmonth} <= 12 && $FORM{spday} >= 1 &&
		    $FORM{spday} <= $daysinmonth[$FORM{spmonth}] && $FORM{spyear} < 100 & $FORM{spyear} >= 0) {
			$bad = "no";
			while (length($FORM{spday}) > 2) { chop($FORM{spday}); }
			while (length($FORM{spyear}) > 2) { chop($FORM{spyear}); }
			$yy = $FORM{spyear};
			if ($yy >= 98) { $yy = "19$yy"; }
			else { $yy = "20$yy"; }
			print "Hits for $months[$FORM{spmonth}-1] $FORM{spday}, $yy\n";
			$stday=$endday=$FORM{spday};
			$stmonth=$endmonth=$FORM{spmonth};
			$styear=$endyear=$FORM{spyear};
			$sthour=0; $stminute=0;
			$endhour=24; $endminute=00;
		}
		else { print "Bad Data"; }
	}
	elsif ($q eq "24hours")
	{
		$bad = "no";
		$stday = $mday - 1;
		$styear = $year;
		$stmonth = $mon;
		$sthour = $hour;
		$stminute = $min;
		$endyear = $year;
		$endmonth = $mon;
		$endday = $mday;
		$endhour = $hour;
		$endminute = $min;	
		if ($stday eq 0) {
			$stmonth--;
			if ($stmonth eq 0) {
				$styear--;
				$stmonth=12;
			}
			$stday = $daysinmonth[$stmonth];
		}
		print "Hits within last 24 hours\n";
	}
	elsif ($q eq "7days")
	{
		$bad = "no";
		$stday = $mday;
		$styear = $year;
		$stmonth = $mon;
		$sthour = 0;
		$stminute = 0;
		$endyear = $year;
		$endmonth = $mon;
		$endday = $mday;
		$endhour = 24;
		$endminute = 0;
		for ($x=7; $x>=1; $x--) {
			$stday--;
			if ($stday eq 0) {
				$stmonth--;
				if ($stmonth eq 0) {
					$styear--;
					$stmonth=12;
				}
				$stday = $daysinmonth[$stmonth];
			}
		}
		print "Hits within last 7 days\n";
	}
	elsif ($q eq "60minutes")
	{
		$bad = "no";
		$stday = $mday;
		$styear = $year;
		$stmonth = $mon;
		$sthour = $hour - 1;
		$stminute = $min;
		$endyear = $year;
		$endmonth = $mon;
		$endday = $mday;
		$endhour = $hour;
		$endminute = $min;	
		if ($hour < 0) {
			$stday--;
			if ($stday eq 0) {
				$stmonth--;
				if ($stmonth eq 0) {
					$styear--;
					$stmonth=12;
				}
				$stday = $daysinmonth[$stmonth];
			}
			$hour = 23;
		}
		print "Hits within last 60 minutes\n";
	}
	elsif ($q eq "2dates")
	{
		if ($FORM{bmonth} >= 1 && $FORM{bmonth} <= 12 && $FORM{bday} >= 1 &&
		    $FORM{bday} <= $daysinmonth[$FORM{bmonth}] && $FORM{byear} < 100 & $FORM{byear} >= 0 &&
		    $FORM{emonth} >= 1 && $FORM{emonth} <= 12 && $FORM{eday} >= 1 &&
		    $FORM{eday} <= $daysinmonth[$FORM{emonth}] && $FORM{eyear} < 100 & $FORM{eyear} >= 0) {
			$bad="no";
			while (length($FORM{spday}) > 2) { chop($FORM{spday}); }
			while (length($FORM{spyear}) > 2) { chop($FORM{spyear}); }
			$yy = $FORM{byear};
			if ($yy >= 98) { $yy = "19$yy"; }
			else { $yy = "20$yy"; }
			$zz = $FORM{eyear};
			if ($zz >= 98) { $zz = "19$zz"; }
			else { $zz = "20$zz"; }

			$stday = $FORM{bday};
			$stmonth = $FORM{bmonth};
			$styear = $FORM{byear};
			$endday = $FORM{eday};
			$endmonth = $FORM{emonth};
			$endyear = $FORM{eyear};
			$sthour = 0; $stminute = 0;
			$endhour = 24; $endminute = 0;
		}

		print "Hits between $months[$FORM{bmonth}-1] $FORM{bday}, $yy and $months[$FORM{emonth}-1] $FORM{eday}, $zz\n";
	}
	elsif ($q eq "sphits")
	{
		$bad = "no";
		$credit = $FORM{lhits};
		print "Last $FORM{lhits} hits\n";
	}
	print "</b></font></center><hr size=5>\n";


### GENERATE CHART HERE ###
if ($bad eq "no") {
	$count = 0;
	$combstartdate = ($styear * 100000000) + ($stmonth * 1000000) + ($stday * 10000) + ($sthour * 100) + $endminute;
	$combenddate = ($endyear * 100000000) + ($endmonth * 1000000) + ($endday * 10000) + ($endhour * 100) + $endminute;
	print "<table border=0>\n";
	$cnt=0;
	foreach $lineofdata (@infile)
	{
		$cnt++;
	}
	for ($x = $cnt; $x>=1; $x--) {
		$lineofdata = $infile[$x];
		($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
		$httprefererlink = $httpreferer;
		chop($remotehost);
		$onoff = "off";
		while (length($httprefererlink) >= 60) { chop($httprefererlink); $onoff = "on";}
		if ($onoff eq "on") { $httprefererlink = "$httprefererlink..."; }
		$recorddate = ($year * 100000000) + ($mon * 1000000) + ($mday * 10000) + ($hour * 100) + $min;
		if ($x eq $cnt && $credit > 0) { $i = "bad"; }


		if (($recorddate <= $combenddate && $recorddate >= $combstartdate) && $q ne "sphits") {
			$count++;
			$color="000088";
			if (($count/2) eq int($count/2)) { $color="006666"; }
			print "<tr><td bgcolor=black valign=top align=right>$count)</td><td bgcolor=#$color>\n";
			if ($year < 98) { $year = "20$year"; }
				else { $year = "19$year"; }
			$ampm = "PM";
			if ($hour < 12) { $ampm = "AM"; }
				else { $hour = $hour - 12; }
			if ($hour eq 0) { $hour = 12; }
			print "On $months[$mon-1] $mday, $year at $hour:$min $ampm, a visitor from $remotehost ($remoteaddr)\n";
			print "visited <b><font color=#40FF40><i>$documenturi</i></font></b>.\n";
			if ($httpreferer ne "") { print "The visitor arrived from <a href=\"$httpreferer\">$httprefererlink</a>.\n"; }
			else { print "The visitor arrived without a referring URL.\n"; }
			print "</td></tr>\n";
		}
		elsif ($q eq "sphits" && $credit >= 1) {
			if ($x ne $cnt) {
				$credit--;
				$count++;
				$color="000088";
				if (($count/2) eq int($count/2)) { $color="006666"; }
				print "<tr><td bgcolor=black valign=top align=right>$count)</td><td bgcolor=#$color>\n";
				if ($year < 98) { $year = "20$year"; }
					else { $year = "19$year"; }
				$ampm = "PM";
				if ($hour < 12) { $ampm = "AM"; }
					else { $hour = $hour - 12; }
				if ($hour eq 0) { $hour = 12; }
				print "On $months[$mon-1] $mday, $year at $hour:$min $ampm, a visitor from $remotehost ($remoteaddr)\n";
				print "visited <b><font color=#40FF40><i>$documenturi</i></font></b>.\n";
				if ($httpreferer ne "") { print "The visitor arrived from <a href=\"$httpreferer\">$httprefererlink</a>.\n"; }
				else { print "The visitor arrived without a referring URL.\n"; }
				print "</td></tr>\n";
			}
		}
	}
	if ($count eq 0) { print "There were no hits within the selected time period.\n"; }
	print "</table>\n";
}
else {
	print "<font color=white size=2	face=\"arial\"><b>Sorry, you did not enter valid information.  Please click the back button, recheck your information, and retry.</b></font>\n";
}
}
### END CHART GENERATION ###


### IF GRAPH ###
elsif ($option eq "graph") {

	if ($q eq "10days") {
		$numdata = 10;
		$type = "lastxdays";
	}
	if ($q eq "20days") {
		$numdata = 20;
		$type = "lastxdays";
	}
	if ($q eq "50days") {
		$numdata = 50;
		$type = "lastxdays";
	}
	if ($q eq "100days") {
		$numdata = 100;
		$type = "lastxdays";
	}

	if ($type eq "lastxdays") {
		$title = "Hits: Last $numdata Days";
		$stday = $mday;
		$styear = $year;
		$stmonth = $mon;
		$combenddate = $styear * 10000 + $stmonth * 100 + $stday;
		$xlabels[$numdata] = "$stmonth/$stday";
		for ($x=($numdata-1); $x>=1; $x--) {
			$stday--;
			if ($stday eq 0) {
				$stmonth--;
				if ($stmonth eq 0) {
					$styear--;
					$stmonth=12;
				}
				$stday = $daysinmonth[$stmonth];
			}
			$xlabels[$x] = "$stmonth/$stday";
		}
		$combstartdate = $styear * 10000 + $stmonth * 100 + $stday;
		print "Hits: Last $numdata Days\n";

	}

	if ($q eq "hour") {
		$title = "Average hits by hour";
		$numdata = 23;
		for ($x = 0; $x <= 23; $x++) {
			if ($x eq 0) { $xlabels[$x+1] = "12 AM"; }
			elsif ($x <= 11) { $xlabels[$x+1] = " $x "; }
			if ($x eq 12) { $xlabels[$x+1] = "12 PM"; }			
			elsif ($x >= 13) { $y = $x - 12; $xlabels[$x+1] = " $y "; }
		}
		$days = 0;
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			if ($mday ne $lastday) { $days++; $lastday = $mday; }
			$xvalues[$hour+1]++;
		}
		for ($x=1; $x<=24; $x++) {
			$xvalues[$x] = $xvalues[$x] / $days;
		}
		print "Average hits by hour\n";
		print "</b></font></center><hr size=5>\n";
		$count = 0;
	}

	if ($q eq "dayofweek") {
		$title = "Avg. hits by day of week";
		$numdata = 7;
		@xlabels = ("", "Sun.", "Mon.", "Tues.", "Wed.", "Thurs.", "Fri.", "Sat.");
		$low = 1000000;
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			$comb = $year * 10000 + $mon * 100 + $mday;
			if ($comb < $low && $mday ne "") { $low = $comb; }
			if ($comb > $high && $mday ne "") { $high = $comb; }
			if ($year <= 94) { $year = "20$year"; }
			else { $year = "19$year"; }
			if ($done{$mon/$mday/$year} ne "yes") {
				$done{$mon/$mday/$year} = "yes";
				$m = $mon;
				$d = $mday;
				$y = $year;
				$leapyear = "no";
				if (($y/4) eq int($y/4)) {
					if ((($y/100) ne int($y/100)) || (($y/400) eq int($y/400)))
					{
						$leapyear = "yes";
					}
				}
				for ($x = 1; $x < $m; $x++) {
					if ($leapyear eq "yes") { $d = $d + $leap[$x]; }
					else { $d = $d + $normal[$x]; }
				}
				while ($d > 7) { $d = $d - 7; }
				$count = 0;
				for ($x = 1995; $x < $y; $x++) {
					if (($x/4) eq int($x/4) && (($x/100) ne int($x/100) ||
				           ($x/400) eq int($x/400))) {
						$count = $count+2;
					}
					else { $count++; }
				}
				$d = $count + $d;
				while ($d > 7) { $d = $d - 7; }	
				$dd{$mon/$mday/$year} = $d;
			}
			else { $d = $dd{$mon/$mday/$year}; }
			$xvalues[$d]++;
		}
		$difference = 0;

		$styear = int($low/10000);
		$stmonth = int(($low - ($styear*10000))/100);
		$stday = int($low - ($styear*10000) - ($stmonth*100));

		while ($newcomb <= $high) {
			$stday++;
			if ($stday > $daysinmonth[$stmonth]) {
				$stmonth++;
				if ($stmonth eq 13) {
					$styear++;
					$stmonth=1;
				}
				$stday = 1;
			}
			$difference++;
			$newcomb = $styear*10000 + $stmonth*100 + $stday;
		}
		$count = 1;
		while ($difference > 7) { $count++; $difference = $difference - 7; }
		for ($x=1; $x<=7; $x++) {
			$xvalues[$x] = $xvalues[$x] / $count;
		}
		print "Average hits by day of week\n";
		print "</b></font></center><hr size=5>\n";
	}

	if ($type eq "lastxdays") {
		print "</b></font></center><hr size=5>\n";
		$count = 0;
		$value = 0;
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			$recorddate = $year * 10000 + $mon * 100 + $mday;
			if ($recorddate >= $combstartdate && $recorddate <= $combenddate)
			{
				for ($x = 1; $x <= $numdata; $x++) {
					if ($xlabels[$x] eq "$mon/$mday") { $numb = $x; } }
				$count++;
				$xvalues[$numb]++;
			}
		}
	}


	$miny = 1000000; $maxy=0;
	for ($x = 1; $x <= $numdata; $x++)
	{
		if ($xvalues[$x] eq "") { $xvalues[$x] = 0; }
		if ($xvalues[$x] > $maxy) { $maxy = $xvalues[$x]; }
		if ($xvalues[$x] < $miny) { $miny = $xvalues[$x]; }
	}
	if ($miny eq 1000000) { $miny = 0; $maxy=10; }
	if ($maxy eq 0) { $maxy = 10; $miny=0; }



### !!! GRAPH CREATOR !!! ###      
	$maxy++;
	if ($miny ne int($miny)) { $miny = int($miny); }
	$labelinterval=int($numdata/8+.5);
	$yinterval=int(($maxy-$miny)/12+.5);
	$im = new GD::Image(440,250);

        # allocate some colors
        $white = $im->colorAllocate(255,255,255);
	$gray = $im->colorAllocate(127,127,127);
	$dkgray = $im->colorAllocate(64,64,64);
	$green = $im->colorAllocate(0,255,0);
        $black = $im->colorAllocate(0,0,0);       
        $red = $im->colorAllocate(255,0,0);      
        $blue = $im->colorAllocate(0,0,255);
	$dkblue = $im->colorAllocate(0,0,128);
	$cyan = $im->colorAllocate(0,255,255);
	$yellow = $im->colorAllocate(255,255,0);

        # make the background transparent and interlaced
        $im->interlaced('true');

	$im->fill(50,50,$black);
        $im->rectangle(0,0,439,249,$white);
	$im->line(1,20,439,20,$white);
	$im->fill(10,10,$dkblue);
	$im->string(gdMediumBoldFont, 5, 5, "$title", $green);
	$im->string(gdSmallFont, 214, 7, "HitLog 1.1 - Dimension's CGI Workshop", $cyan);
	$im->line(40,232,438,232,$gray);
	$step = int(400/$numdata);
	for ($x = 40; $x<=439; $x=$x+$step) {
		if ($x >= 40 && $x < 439) {
			$im->line($x,230,$x,234,$gray);
		}
	}

	$count = $miny;

	if ($yinterval eq 0) { $yinterval = 1; }
	$sub = int(204/(($maxy-$miny)/$yinterval)+.5);
	for ($y = 226; $y >= 21; $y=$y-$sub) {
		$l = length("$count");
		if ($y >= 26) {	$im->string(gdSmallFont, 37-(6*$l), $y, "$count", $white); }
		if ($y < 222 && $y > 25) { $im->line(40,$y+6,438,$y+6,$dkgray); }
		$count = $count + $yinterval;
	}
	$labelnum = 1;
	for ($x = 40; $x <=438; $x=$x+($step*$labelinterval)) {
		while (length("$xlabels[$labelnum]") > 6) { chop($xlabels[$labelnum]); }
		$l = length("$xlabels[$labelnum]");
		$l = int(($l*6)/2);
		if ($x + $l < 437) { $im->string(gdSmallFont, $x-$l+1, 235, "$xlabels[$labelnum]", $white); }
		$labelnum=$labelnum+$labelinterval;
	}


	$count = 1;
	for ($x = 40; $x<=438; $x=$x+int(400/$numdata)) {

		$y = $xvalues[$count] - $miny;
		$y = 232 - ($y * ($sub / $yinterval));
		if ($count ne 1) { $im->line($oldx, $oldy, $x, $y, $yellow); }
		$oldx = $x; $oldy = $y;
		$count++;
	}
	open (FILE, ">$tempgif");
        print FILE $im->gif;
	close (FILE);

	print "<center><img src=\"$tgifurl\"></center>\n";
}

elsif ($option eq "bars") {
	if ($q eq "domains") {
		print "Domains of Referring URLs\n";
		$thisaddr = $ENV{HTTP_HOST};
		$len = length($thisaddr);
		for ($x = 1; $x <= $len; $x++) {
			$c = chop($thisaddr);
			$backwords = "$backwords" . "$c";
		}
		($one,$two,$a) = split(/\./, $backwords);
		$backwords = "$one" . "." . "$two";
		$len = length($backwords);
		$forwards = "";
		for ($x = 1; $x <= $len; $x++) {
			$c = chop($backwords);
			$forwards = "$forwards" . "$c";
		}
		$thisaddr=$forwards;
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			$backwords = "";
			($a, $a, $httpreferer, $a) = split(/\//, $httpreferer);
			$len = length($httpreferer);
			for ($x = 1; $x <= $len; $x++) {
				$c = chop($httpreferer);
				$backwords = "$backwords" . "$c";
			}
			($one,$two,$a) = split(/\./, $backwords);
			$backwords = "$one" . "." . "$two";
			$len = length($backwords);
			$forwards = "";
			for ($x = 1; $x <= $len; $x++) {
				$c = chop($backwords);
				$forwards = "$forwards" . "$c";
			}

			if ($forwards ne "." && $forwards ne "$thisaddr") { $labels{$forwards}++; }
		}
	}
	elsif ($q eq "localdocumenthits") {
		print "Local Document Hits\n";
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			$labels{$documenturi}++;
		}
	}
	elsif ($q eq "address") {
		print "First Level Domains of Visitors\n";
		foreach $lineofdata (@infile)
		{
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			chop($remotehost);
			$chp = chop($remotehost);
			$remotehost = "$remotehost" . "$chp";
			if ($chp eq "0" || $chp eq "1" || $chp eq "2" || $chp eq "3" || $chp eq "4" || $chp eq "5" || $chp eq "6" || $chp eq "7" || $chp eq "8" || $chp eq "9") {
				$labels{'IP Address Only'}++;
			}
			else {
				$backwords = "";
				$len = length($remotehost);
				for ($x = 1; $x <= $len; $x++) {
					$c = chop($remotehost);
					$backwords = "$backwords" . "$c";
				}
				($one,$two,$a) = split(/\./, $backwords);
				$backwords = "$one" . "." . "$two";
				$len = length($backwords);
				$forwards = "";
				for ($x = 1; $x <= $len; $x++) {
					$c = chop($backwords);
					$forwards = "$forwards" . "$c";
				}
				$labels{$forwards}++;
			}
		}
	}

	print "</b></font></center><hr size=5>\n";

	$count=0;
	$totalvalue=0;

	foreach $key (keys(%labels)) {
		$count++;
		$label[$count]=$key;
		$value[$count]=$labels{$key};
		$totalvalue=$totalvalue+$labels{$key};
	}

	for ($i = 1; $i <= ($count-1); $i++) {
		for ($j = 1; $j <= ($count - %i); $j++) {
			if ($value[$j] < $value[$j+1]) {
				$temp = $value[$j+1];
				$value[$j+1] = $value[$j];
				$value[$j] = $temp;
				$temp = $label[$j+1];
				$label[$j+1] = $label[$j];
				$label[$j] = $temp;
			}
		}
	}

	print "<table width=100% border=0 cellspacing=0 cellpadding=0>\n";
	for ($x = 1; $x <= $count; $x++) {
		print "<tr><td align=right bgcolor=black><font color=white size=2 face=\"arial\">$label[$x]&nbsp;</font></td><td align=right width=100><font color=cyan size=2 face=\"arial\">$value[$x] (",int($value[$x]/$totalvalue*1000)/10,"%)&nbsp;</font></td><td bgcolor=black align=left width=350><img src=\"$bargraph\" width=",int(($value[$x]/$totalvalue)*350)," height=12></td></tr>\n";
	}

	print "</table>\n";
	
}  

print "<hr size=5></td></tr></table></center><center><font color=white size=2 face=\"arial\">Copyright (C) 1998-1999 <a href=\"http://www.cgiworkshop.com/dimension/\">Dimension's CGI Workshop</a>, all rights reserved.</center></body></html>\n";